package com.ftl.flappybird.day3;

import java.awt.Color;//ɫ Color.class
import java.awt.Graphics;
import java.awt.image.BufferedImage;//ͼƬ
import java.util.Random;

import javax.imageio.ImageIO;//ȡͼƬĹ
import javax.swing.JFrame;//ڿ
import javax.swing.JPanel;// װ


/**
 * flappyBird
 * @author Administrator
 *
 */
class MyPanel extends JPanel {
	// ˱(background)ͼûͼƬ
	BufferedImage background;
	Bird bird;  	 //
	Ground ground; 	//MyPanelа
	Column column1;	//ΪMyPanel
	Column column2;	//ΪMyPanel
	

	// áʼȡͼƬ
	// һ
	public MyPanel() throws Exception {
		// ʹImageIOread
		// "bg.png"ȡΪһͼƬ͵Ķ
		// background ͼƬ
		background = ImageIO.read(getClass().getResource("bg.png"));
		ground = new Ground();
		//
		column1 = new Column(1);
		column2 = new Column(2);
		bird = new Bird();
		System.out.println("Demo3");
	}

	// ޸JPanelĻƷ
	// Graphics ͼ
	// paint Ϳ
	// draw  ImageͼƬ
	
	
	//ж
		// TODO Զɵķ

	public void action() throws Exception{
		while(true){
			this.ground.step();
			this.column1.step();
			this.column2.step();
			this.bird.step();
			
			repaint();
			Thread.sleep( 1000 / 30);
		}
	}
	
	public void paint(Graphics g) {
		// 0,0λûbackgroundͼƬ
		g.drawImage(background, 0, 0, null);
		g.drawImage(bird.image, bird.x - bird.width/2, 
				bird.y - bird.height/2, null);
		g.drawImage(column1.image,
				column1.x-column1.width/2,
				column1.y-column1.height/2,null);
		g.drawImage(column2.image,
				column2.x-column2.width/2,
				column2.y-column2.height/2,null);
		g.drawImage(ground.image, ground.x, ground.y, null);


	}
}

class Column{
	public int x,y;	//x,yӵķ϶ĵ
	public int width, height;  //ӵĿ 
	public BufferedImage image;   //ӵͼƬ
	public int gap;			//϶
	public int distance;    //2֮ľ
	
	//n ӵıţ磺1,2
	public Column(int n) throws Exception{
		image = ImageIO.read(Demo3.class.getResource("column.png"));
		this.distance = 245;
		//һʼֱСͼƬ118ľ   550 = 118 + 432
		this.x = 550 + (n - 1) * distance;
		Random random = new Random();
		this.y = random.nextInt(128) + 132;
		this.gap = 144;
		this.width = image.getWidth();
		this.height = image.getHeight();
	}
	
	public void step(){
		this.x--;
		if(this.x <= -this.width/2){
			this.x = this.distance * 2 - this.width / 2;
			Random random = new Random();
			this.y = random.nextInt(128) + 132;
		}
	}
	
}

class Ground{
	public BufferedImage image;
	public int x,y;
	
	public Ground() throws Exception{
		image = ImageIO.read(getClass().getResource("ground.png"));
		this.x = 0;
		this.y = 500;
	}
	public void step(){
		this.x--;    //x1
		if(this.x == -109){
			this.x = 0;
		}

	}
}

class Bird{
	public BufferedImage image;
	public int x,y;    //λãĵ
	public int width, height;   
	public int size;   		//ĴСײⷶΧ
	public double g;		//ٶȣǸͣСͣ
	public double t;		//ʱ䣬ƶļʱ
	public double s;		//μʱ䣬ƶľ룺λ
	public double v0;		//ʼٶ
	public double speed;	//ʱtԺ󣬵˶ٶ
	public double alpha;	//,  ԻΪλ
	
	
	
	
	public Bird() throws Exception{
		this.image = ImageIO.read(
				getClass().getResource("0.png"));
		this.x = 132;
		this.y = 280;
		this.size = 40;
		this.g = 4;
		this.t = 0.25;
		this.v0 = 35;
		this.s = 0;
		this.speed = this.v0;
		this.alpha = 0;
		this.width = this.image.getWidth();
		this.height = this.image.getHeight();
	}
	public void step(){
		//ǰ׳ʼٶ
		double v0 = speed;
		//λ
		this.s = v0 * t + g * t * t / 2;
		this.y = this.y - (int)s;
		//㾭ʱtԺٶȣ´μ
		//ĳʼٶ
		double v = v0 - g * t;
		//ʱtԺٶΪ´εĳʼٶ
		this.speed = v;
//		System.out.println("λƣ" + this.s + "y:" + this.y + "\tt:" + this.t + "\tspeed:" + this.speed);
		if(this.y >= 280){
			this.y = 280;
			this.speed = 35;
		}
	}
	
}

public class Demo3 {
	public static void main(String[] args) throws Exception {
		// һڿ򣬱frame
		JFrame frame = new JFrame();
		// ,panel
		// new MyPanel()ִ˹װƬ
		MyPanel panel = new MyPanel();
		// Background ñɫ=ɫ
		panel.setBackground(Color.BLUE);
		// frameõĿpanelõ
		// 
		frame.add(panel);
		frame.setSize(432, 644 + 30);
		// Locationλ Relative To 
		frame.setLocationRelativeTo(null);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.setTitle("FlappyBird2017");
		frame.setIconImage(ImageIO.read(
				Demo3.class.getResource("0.png")));
		// setVisibleִеʱ򣬾ִ
		// paint 
		frame.setVisible(true);
		panel.action();
	}
}

